<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Statistics.php 1239 2005-01-17 17:39:11Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage Statistics
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once maintenancePath . '/maintenance-common.php';
 
/**
 * A factory class for creating Maintenance_Statistics_Common subclass objects.
 */
class Maintenance_Statistics
{
    /**
     * The factory method used to instantiate a class that implements the
     * Maintenance_Statistics_Common interface.
     *
     * @param string $classname The name of the class to instantiate.
     * @param Maintenance_Statistics_Common $msObj A reference to the class
     *                                             object that will be created.
     * @param Date $now Optional Date representing the current date/time. Normally
     *                  just used for testing the class constructor, or for 
     *                  faking the current time in order to re-generate past statistics,
     *                  in the case of faulty raw data tables.
     * @param Date $lastUpdated Optional Date representing the date/time the
     *                          statistics were last updated. Only used when
     *                          regenerating statistics.
     */
    function instance($classname, &$msObj, $now = null, $lastUpdated = null)
    {
        $conf =& $GLOBALS['_MAX']['CONF'];
        $filename  = 'Statistics' . $classname;
        $classname = 'Maintenance_Statistics_' . $classname;
        include_once maintenancePath . "/libraries/max/Maintenance/{$filename}.php";
        if (!class_exists($classname)) {
            // Unable to include the specified class file - raise error and halt
            debug('Unable to find the "' . $classname . '" class in the "/libraries/max/Maintenance/' .
                  $filename . '.php" file.', PEAR_LOG_ERROR);
            debug('Aborting script execution', PEAR_LOG_ERROR);
            exit();
        }
        // Instantiate the class (note eval() hack is due to lack
        // of variable classname/static method call support in PHP)
        eval('$msObj = new ' . $classname . '($now, $lastUpdated);');
    }
}

?>
